/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.11 by edhill, Mon Sep 29 16:15:23 2003 UTC revision 1.102 by edhill, Mon Oct 4 18:59:36 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20    }
21    
22    # Search for particular CPP #cmds associated with MPI
23    # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24    test_for_mpi_in_cpp_eeoptions() {
25        cpp_options=$1
26        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38        RETVAL=$?
39        if test "x${RETVAL}" = x0 ; then
40            printf "Error: In $file there is an illegal line: "
41            grep -i "$strng" $file
42            return 1
43        fi
44        return 0
45    }
46    
47    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
48    # the package list.
49    expand_pkg_groups() {
50        new_packages=
51        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
52        if test -r $PKG_GROUPS ; then
53            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
54            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
55            matched=0
56            for i in $PACKAGES ; do
57                line=`grep "^ *$i" ./p2.tmp`
58                RETVAL=$?
59                if test "x$RETVAL" = x0 ; then
60                    matched=1
61                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
62                    echo "    replacing \"$i\" with: $replace"
63                    new_packages="$new_packages $replace"
64                else
65                    new_packages="$new_packages $i"
66                fi
67            done
68            PACKAGES=$new_packages
69            rm -f ./p[1,2].tmp
70            return $matched
71        else
72            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73        fi
74    }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
253            
254      echo "test" > test      echo "test" > test
255      ln -s ./test link      ln -s ./test link
# Line 45  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # look for possible fortran compilers      look_for_makedepend
271      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"  
272        #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
316          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 63  EOF Line 327  EOF
327              p_FC="$p_FC $c"              p_FC="$p_FC $c"
328          fi          fi
329      done      done
330        rm -f ./hello.f ./hello
331      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
332          cat 1>&2 <<EOF          cat 1>&2 <<EOF
333    
# Line 70  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 78  EOF Line 343  EOF
343          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | awk '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 144  get_pdepend_list()  { Line 418  get_pdepend_list()  {
418      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
419      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
420      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
421          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
422          > ./.pd_tmp          > ./.pd_tmp
423      source ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
430  #  Explain usage  #  Explain usage
431  usage()  {  usage()  {
432      echo  cat <<EOF
433      echo "Usage: "$0" [OPTIONS]"  
434      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
435      echo    where [OPTIONS] can be:
436      echo "    -help | --help | -h | --h"  
437      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
438      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
439      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
440      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
443      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
444      echo "    -make NAME | -m NAME"  
445      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
446      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
448      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
449      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
450      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
451      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
452      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
453      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
454      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
455      echo "      -disable=NAME | --disable=NAME"  
456      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
457      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
458      echo "    -noopt NAME | --noopt NAME"            Get the default package list from "NAME".
459      echo "      -noopt=NAME | --noopt=NAME"  
460  #    echo "    -cpp NAME | --cpp NAME"      -make NAME | -m NAME
461  #    echo "      -cpp=NAME | --cpp=NAME"        --make=NAME | -m=NAME
462      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"            Use "NAME" for the MAKE program. The default is "make" but
463      echo "      -fc=NAME | --fc=NAME"            many platforms, "gmake" is the preferred choice.
464      echo "    -[no]ieee | --[no]ieee"  
465      echo "    -[no]mpi | --[no]mpi"      -makefile NAME | -mf NAME
466      echo "    -[no]jam | --[no]jam"        --makefile=NAME | -mf=NAME
467      echo            Call the makefile "NAME".  The default is "Makefile".
468      echo "  and NAME is a string such as:"  
469      echo      -makedepend NAME | -md NAME
470      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"        --makedepend=NAME | -md=NAME
471      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            Use "NAME" for the MAKEDEPEND program.
472      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"  
473      echo      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474      echo "  which, depending upon your shell, may need to be single-quoted"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475      echo "  if it contains spaces, dashes, or other special characters."            Specify the location of the MITgcm ROOTDIR as "NAME".
476              By default, genamke will try to find the location by
477              looking in parent directories (up to the 5th parent).
478    
479        -mods NAME | --mods NAME | -mo NAME | --mo NAME
480          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
481              Here, "NAME" specifies a list of directories that are
482              used for additional source code.  Files found in the
483              "mods list" are given preference over files of the same
484              name found elsewhere.
485    
486        -disable NAME | --disable NAME
487          -disable=NAME | --disable=NAME
488              Here "NAME" specifies a list of packages that we don't
489              want to use.  If this violates package dependencies,
490              genamke will exit with an error message.
491    
492        -enable NAME | --enable NAME
493          -enable=NAME | --enable=NAME
494              Here "NAME" specifies a list of packages that we wish
495              to specifically enable.  If this violates package
496              dependencies, genamke will exit with an error message.
497    
498        -standarddirs NAME | --standarddirs NAME
499          -standarddirs=NAME | --standarddirs=NAME
500              Here, "NAME" specifies a list of directories to be
501              used as the "standard" code.
502    
503        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
504          -fc=NAME | --fc=NAME
505              Use "NAME" as the fortran compiler.  By default, genmake
506              will search for a working compiler by trying a list of
507              "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514        -[no]ieee | --[no]ieee
515              Do or don't use IEEE numerics.  Note that this option
516              *only* works if it is supported by the OPTFILE that
517              is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529      While it is most often a single word, the "NAME" variables specified
530      above can in many cases be a space-delimited string such as:
531    
532        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
533        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
534        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
535    
536      which, depending upon your shell, may need to be single-quoted.
537    
538      For more detailed genmake documentation, please see:
539    
540        http://mitgcm.org/devel_HOWTO/
541    
542    EOF
543    
544      exit 1      exit 1
545  }  }
546    
547  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
548  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
549  #eh3 set CPP        = ( '/lib/cpp -P' )  
550  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551  #eh3 set KPP        = (  )      if test ! "x$FC_NAMEMANGLE" = x ; then
552  #eh3 set FC         = ( 'f77' )          return 0
553  #eh3 set LINK       = $FC      fi
554  #eh3 set MAKEDEPEND = ( 'makedepend' )  
555  #eh3 set INCLUDES   = ( -I. )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556  #eh3 set FFLAGS     = (  )      
557  #eh3 set FOPTIM     = (  )      cat > genmake_test.c <<EOF
558  #eh3 set CFLAGS     = (  )  void tcall( char * string ) { tsub( string ); }
559  #eh3 set KFLAGS1    = (  )  EOF
560  #eh3 set KFLAGS2    = (  )      $MAKE genmake_test.o >> genmake_warnings 2>&1
561  #eh3 set LIBS       = (  )      RETVAL=$?
562  #eh3 set KPPFILES   = (  )      if test "x$RETVAL" != x0 ; then
563  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          FC_NAMEMANGLE=$default_nm
564  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          cat <<EOF>> genmake_errors
565    
566    WARNING: C test compile fails
567    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
568    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
569    EOF
570            return 1
571        fi
572        c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573        RETVAL=$?
574        if test "x$RETVAL" != x0 ; then
575            FC_NAMEMANGLE=$default_nm
576            cat <<EOF>> genmake_warnings
577    
578    WARNING: The "nm" command failed.
579    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
580    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
581    EOF
582            return 1
583        fi
584        cat > genmake_tcomp.f <<EOF
585          subroutine tcall( string )
586          character*(*) string
587          call tsub( string )
588          end
589    EOF
590        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
591        RETVAL=$?
592        if test "x$RETVAL" != x0 ; then
593            FC_NAMEMANGLE=$default_nm
594            cat <<EOF>> genmake_warnings
595    
596    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
597    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
598    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
599    EOF
600            return 1
601        fi
602        f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603        RETVAL=$?
604        if test "x$RETVAL" != x0 ; then
605            FC_NAMEMANGLE=$default_nm
606            cat <<EOF>> genmake_warnings
607    
608    WARNING: The "nm" command failed.
609    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
610    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
611    EOF
612            return 1
613        fi
614    
615        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
616        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
617        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
618        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
619    
620        nmangle="X"
621        if test "x$c_a" != "x$f_a" ; then
622            comm="echo x$f_a | sed -e 's|x$c_a||'"
623            a=`eval $comm`
624            nmangle="$a ## $nmangle"
625        fi
626        if test "x$c_b" != "x$f_b" ; then
627            comm="echo x$f_b | sed -e 's|x$c_b||'"
628            b=`eval $comm`
629            nmangle="$nmangle ## $b"
630        fi
631    
632        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
633    
634        #  cleanup the testing files
635        rm -f genmake_tcomp.* genmake_test.*
636    }
637    
638    
639    check_HAVE_CLOC()  {
640        get_fortran_c_namemangling
641        cat <<EOF > genmake_tc_1.c
642    $FC_NAMEMANGLE
643    #include <stdio.h>
644    #include <stdlib.h>
645    #include <unistd.h>
646    #include <assert.h>
647    #include <sys/time.h>
648    void FC_NAMEMANGLE(cloc) ( double *curtim )
649    {
650     struct timeval tv1;
651     gettimeofday(&tv1 , (void *)NULL );
652     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
653     *curtim = *curtim/1.E6;
654    }
655    EOF
656        make genmake_tc_1.o >> genmake_tc.log 2>&1
657        RET_C=$?
658        cat <<EOF > genmake_tc_2.f
659          program hello
660          Real*8 wtime
661          external cloc
662          call cloc(wtime)
663          print *," HELLO WORLD", wtime
664          end program hello
665    EOF
666        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
667        RET_F=$?
668        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
669        RETVAL=$?
670        if test "x$RETVAL" = x0 ; then
671            HAVE_CLOC=t
672            DEFINES="$DEFINES -DHAVE_CLOC"
673        fi
674        rm -f genmake_tc*
675    }
676    
677    
678    check_netcdf_libs()  {
679        echo "" > genmake_tnc.log
680        cat <<EOF > genmake_tnc.for
681          program fgennc
682    #include "netcdf.inc"
683          integer iret, ncid, xid
684          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
685          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
686          iret = nf_def_dim(ncid, 'X', 11, xid)
687          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
688          iret = nf_close(ncid)
689          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
690          end
691    EOF
692        #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"
693        #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"
694        #echo "$LINK -o genmake_tnc.o $LIBS"
695        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
696            &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
697            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
698        RET_COMPILE=$?
699    
700        #EH3  Remove test program execution for machines that either disallow
701        #EH3  execution or cannot support it (eg. cross-compilers)
702        #EH3
703        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
704        #EH3 RETVAL=$?
705        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
706    
707        if test "x$RET_COMPILE" = x0 ; then
708            HAVE_NETCDF=t
709        else
710            # try again with "-lnetcdf" added to the libs
711            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
712                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
713                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
714            RET_COMPILE=$?
715            if test "x$RET_COMPILE" = x0 ; then
716                LIBS="$LIBS -lnetcdf"
717                HAVE_NETCDF=t
718            else
719                cat genmake_tnc.log >> genmake_warnings
720            fi
721        fi
722        rm -f genmake_tnc*
723    }
724    
725    
726    
727    ###############################################################################
728    #   Sequential part of script starts here
729    ###############################################################################
730    
731  #  Set defaults here  #  Set defaults here
732  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 229  LN= Line 736  LN=
736  S64=  S64=
737  KPP=  KPP=
738  FC=  FC=
739    #CC=gcc
740    CPP=
741  LINK=  LINK=
742  DEFINES="-DWORDLENGTH=4"  DEFINES=
743  PACKAGES=  PACKAGES=
744  ENABLE=  ENABLE=
745  DISABLE=  DISABLE=
746  MAKEFILE=  MAKEFILE=
747  MAKEDEPEND=  #MAKEDEPEND=
748  PDEPEND=  PDEPEND=
749  DUMPSTATE=t  DUMPSTATE=t
750  PDEFAULT=  PDEFAULT=
# Line 246  FOPTIM= Line 755  FOPTIM=
755  CFLAGS=  CFLAGS=
756  KFLAGS1=  KFLAGS1=
757  KFLAGS2=  KFLAGS2=
758    #LDADD=
759  LIBS=  LIBS=
760  KPPFILES=  KPPFILES=
761  NOOPTFILES=  NOOPTFILES=
762  NOOPTFLAGS=  NOOPTFLAGS=
763    MPI=
764    MPIPATH=
765    
766    # DEFINES checked by test compilation
767    HAVE_SYSTEM=
768    HAVE_FDATE=
769    FC_NAMEMANGLE=
770    HAVE_CLOC=
771    HAVE_NETCDF=
772    HAVE_ETIME=
773    
774  MODS=  MODS=
775  TOOLSDIR=  TOOLSDIR=
776  SOURCEDIRS=  SOURCEDIRS=
777  INCLUDEDIRS=  INCLUDEDIRS=
778    STANDARDDIRS="USE_THE_DEFAULT"
779    
780    G2ARGS=
781    BASH=
782  PWD=`pwd`  PWD=`pwd`
783  MAKE=make  MAKE=make
784  THISHOSTNAME=`hostname`  AWK=awk
785    THISHOST=`hostname`
786  THISCWD=`pwd`  THISCWD=`pwd`
787  THISDATE=`date`  THISDATE=`date`
788    THISUSER=`echo $USER`
789    THISVER=
790  MACHINE=`uname -a`  MACHINE=`uname -a`
791  EXECUTABLE=  EXECUTABLE=
792  EXEHOOK=  EXEHOOK=
793  EXEDIR=  EXEDIR=
794    PACKAGES_CONF=
795    IEEE=
796    if test "x$MITGCM_IEEE" != x ; then
797        IEEE=$MITGCM_IEEE
798    fi
799    FS=
800    FS90=
801    
802    AUTODIFF_PKG_USED=f
803    AD_OPTFILE=
804    TAF=
805    AD_TAF_FLAGS=
806    FTL_TAF_FLAGS=
807    SVD_TAF_FLAGS=
808    TAF_EXTRA=
809    TAMC=
810    AD_TAMC_FLAGS=
811    FTL_TAF_FLAGS=
812    SVD_TAMC_FLAGS=
813    TAMC_EXTRA=
814    
815    
816  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
817  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
818  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
819    
820  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
821  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
822  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
823  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
824  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
825    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
826    
827  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
828    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
829    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
830    gm_s12="TAF_EXTRA TAMC_EXTRA"
831    
832    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
833    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
834    
835    cat <<EOF
836    
837    GENMAKE :
838    
839    A program for GENerating MAKEfiles for the MITgcm project.  For a
840    quick list of options, use "genmake -h" or for more detail see:
841    
842      http://mitgcm.org/devel_HOWTO/
843    
844    EOF
845    
 echo  
846  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
847  gm_local="./gm_local"  gm_local="genmake_local"
848  echo -n "  getting local config information:  "  for i in . $MODS ; do
849  if test -e $gm_local ; then      if test -r $i/$gm_local ; then
850            . $i/$gm_local
851            break
852        fi
853    done
854    printf "  getting local config information:  "
855    if test -f $gm_local ; then
856      echo "using $gm_local"      echo "using $gm_local"
857      source $gm_local      . $gm_local
858      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
859      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
860  else  else
861      echo "none found"      echo "none found"
862  fi  fi
863    
864  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  echo "$0::$1:$2:$3:$4:$5:$6:$7:"
865  #OPTIONS=  #OPTIONS=
866  #n=0  #n=0
867  #for i ; do  #for i ; do
# Line 303  fi Line 872  fi
872  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
873  #done  #done
874  #parse_options  #parse_options
   
875  ac_prev=  ac_prev=
876  for ac_option ; do  for ac_option in "$@" ; do
877    
878        G2ARGS="$G2ARGS \"$ac_option\""
879    
880      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
881      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 328  for ac_option ; do Line 898  for ac_option ; do
898          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
899              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
900                    
901            -adoptfile | --adoptfile | -adof | --adof)
902                ac_prev=AD_OPTFILE ;;
903            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
904                AD_OPTFILE=$ac_optarg ;;
905            
906          -pdepend | --pdepend)          -pdepend | --pdepend)
907              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
908          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 343  for ac_option ; do Line 918  for ac_option ; do
918          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
919              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
920                    
921            -bash | --bash)
922                ac_prev=BASH ;;
923            -bash=* | --bash=*)
924                BASH=$ac_optarg ;;
925            
926            -makedepend | --makedepend | -md | --md)
927                ac_prev=MAKEDEPEND ;;
928            -makedepend=* | --makedepend=* | -md=* | --md=*)
929                MAKEDEPEND=$ac_optarg ;;
930            
931          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
932              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
933          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
934              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
935                    
936          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
937              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
938          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
939              PLATFORM=$ac_optarg ;;              echo
940                usage
941                ;;
942                    
943          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
944              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 373  for ac_option ; do Line 960  for ac_option ; do
960          -enable=* | --enable=*)          -enable=* | --enable=*)
961              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
962                    
963          -noopt | --noopt)          -standarddirs | --standarddirs)
964              ac_prev=NOOPT ;;              ac_prev=STANDARDDIRS ;;
965          -noopt=* | --noopt=*)          -standarddirs=* | --standarddirs=*)
966              NOOPT=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
967            
968  #           -cpp | --cpp)  #           -cpp | --cpp)
969  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
970  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
971  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
972                        
973            -cc | --cc)
974                ac_prev=CC ;;
975            -cc=* | --cc=*)
976                CC=$ac_optarg ;;
977            
978          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
979              ac_prev=FC ;;              ac_prev=FC ;;
980          -fc=* | --fc=*)          -fc=* | --fc=*)
981              FC=$ac_optarg ;;              FC=$ac_optarg ;;
982                    
983            -fs | --fs)
984                ac_prev=FS ;;
985            -fs=* | --fs=*)
986                FS=$ac_optarg ;;
987            
988            -fs90 | --fs90)
989                ac_prev=FS90 ;;
990            -fs90=* | --fs90=*)
991                FS90=$ac_optarg ;;
992            
993          -ieee | --ieee)          -ieee | --ieee)
994              IEEE=1 ;;              IEEE=true ;;
995          -noieee | --noieee)          -noieee | --noieee)
996              IEEE=0 ;;              IEEE= ;;
997            
998          -mpi | --mpi)          -mpi | --mpi)
999              MPI=1 ;;              MPI=true ;;
1000          -nompi | --nompi)          -mpi=* | --mpi=*)
1001              MPI=0 ;;              MPIPATH=$ac_optarg
1002                        MPI=true ;;
1003          -jam | --jam)          
1004              JAM=1 ;;  #       -jam | --jam)
1005          -nojam | --nojam)  #           JAM=1 ;;
1006              JAM=0 ;;  #       -nojam | --nojam)
1007    #           JAM=0 ;;
1008                    
1009          -ds | --ds)          -ds | --ds)
1010              DUMPSTATE=t ;;              DUMPSTATE=t ;;
1011                    
1012            -taf_extra | --taf_extra)
1013                ac_prev=TAF_EXTRA ;;
1014            -taf_extra=* | --taf_extra=*)
1015                TAF_EXTRA=$ac_optarg ;;
1016    
1017            -tamc_extra | --tamc_extra)
1018                ac_prev=TAMC_EXTRA ;;
1019            -tamc_extra=* | --tamc_extra=*)
1020                TAMC_EXTRA=$ac_optarg ;;
1021    
1022          -*)          -*)
1023              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1024              usage              usage
# Line 420  for ac_option ; do Line 1033  for ac_option ; do
1033            
1034  done  done
1035    
1036    if test -f ./.genmakerc ; then
1037        echo
1038        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1039        echo "  file.  This file format is no longer supported.  Please see:"
1040        echo
1041        echo "    http://mitgcm.org/devel_HOWTO/"
1042        echo
1043        echo "  for directions on how to setup and use the new \"genmake2\" input"
1044        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
1045        echo
1046    fi
1047    
1048    #  Find the MITgcm ${ROOTDIR}
1049  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1050      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1051        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1052          ROOTDIR=".."          ROOTDIR=".."
1053      else      else
1054          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1055              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1056                  ROOTDIR=$d                  ROOTDIR=$d
1057                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1058                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1059                  break                  break
1060              fi              fi
# Line 445  if test ! -d ${ROOTDIR} ; then Line 1072  if test ! -d ${ROOTDIR} ; then
1072      exit 1      exit 1
1073  fi  fi
1074    
1075    #  Find the MITgcm ${THISVER}
1076    if test -f "${ROOTDIR}/doc/tag-index" ; then
1077        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1078    fi
1079    
1080  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1081  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1082      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 458  fi Line 1090  fi
1090  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
1091      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1092          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1093          source "$OPTFILE"          . "$OPTFILE"
1094          RETVAL=$?          RETVAL=$?
1095          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1096              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1097              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1098              exit 1              exit 1
1099          fi          fi
1100          if test "x$DUMPSTATE" != xf ; then          if test "x$DUMPSTATE" != xf ; then
1101              cp -f $OPTFILE "gm_optfile"              cp -f $OPTFILE "genmake_optfile"
1102          fi          fi
1103      else      else
1104          echo "Error: can't read OPTFILE=\"$OPTFILE\""          echo "Error: can't read OPTFILE=\"$OPTFILE\""
# Line 474  if test "x$OPTFILE" != xNONE ; then Line 1106  if test "x$OPTFILE" != xNONE ; then
1106      fi      fi
1107  fi  fi
1108    
1109  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1110  #  and abort!  # check_for_broken_Ff
1111    
1112    echo "  getting AD_OPTFILE information:  "
1113    if test "x${AD_OPTFILE}" = x ; then
1114        if test "x$MITGCM_AD_OF" = x ; then
1115            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1116        else
1117            AD_OPTFILE=$MITGCM_AD_OF
1118        fi
1119    fi
1120    if test "x${AD_OPTFILE}" != xNONE ; then
1121        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1122            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1123            . "$AD_OPTFILE"
1124            RETVAL=$?
1125            if test "x$RETVAL" != x0 ; then
1126                printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1127                echo "--please check that variable syntax is bash-compatible"
1128                exit 1
1129            fi
1130            if test "x$DUMPSTATE" != xf ; then
1131                cp -f $AD_OPTFILE "genmake_ad_optfile"
1132            fi
1133        else
1134            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1135            exit 1
1136        fi
1137    fi
1138    
1139    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1140    #  either set defaults or complain and abort!
1141    if test ! "x$BASH" = x ; then
1142        # add a trailing space so that it works within the Makefile syntax (see below)
1143        BASH="$BASH "
1144    fi
1145  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1146      cat <<EOF 1>&2      cat <<EOF 1>&2
1147    
1148  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
1149    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1150    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
1151    3) the "./gm_local" file    3) the "./genmake_local" file
1152  EOF  EOF
1153      exit 1      exit 1
1154  fi  fi
1155    if test "x$CC" = x ; then
1156        CC=cc
1157    #     cat <<EOF 1>&2
1158    # Error: no C compiler: please specify using one of the following:
1159    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1160    #   2) the "-cc=XXX" command-line option
1161    #   3) the "./genmake_local" file
1162    # EOF
1163    #     exit 1
1164    fi
1165  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1166      LINK=$FC      LINK=$FC
1167  fi  fi
1168    if test "x$MAKE" = x ; then
1169        MAKE="make"
1170    fi
1171  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1172      CPP="cpp"      CPP=cpp
1173  fi  fi
1174  echo "#define A a" | cpp > test_cpp 2>&1  #EH3 === UGLY ===
1175    #  The following is an ugly little hack to check for $CPP in /lib/ and
1176    #  it should eventually be replaced with a more general function that
1177    #  searches a combo of the user's path and a list of "usual suspects"
1178    #  to find the correct location for binaries such as $CPP.
1179    for i in " " "/lib/" ; do
1180        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1181    done
1182    #EH3 === UGLY ===
1183    echo "#define A a" | $CPP > test_cpp 2>&1
1184  RETVAL=$?  RETVAL=$?
1185  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1186      cat <<EOF 1>&2      cat <<EOF 1>&2
# Line 500  if test "x$RETVAL" != x0 ; then Line 1188  if test "x$RETVAL" != x0 ; then
1188  Error: C pre-processor "$CPP" failed the test case: please specify using:  Error: C pre-processor "$CPP" failed the test case: please specify using:
1189    
1190    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1191    2) the "./gm_local" file    2) the "./genmake_local" file
1192      3) with the CPP environment variable
1193    
1194  EOF  EOF
1195      exit 1      exit 1
1196  else  else
1197      rm -f test_cpp      rm -f test_cpp
1198  fi  fi
1199  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1200      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1201        LN="ln -s"
1202    fi
1203    echo "test" > genmake_test_ln
1204    $LN genmake_test_ln genmake_tlink
1205    RETVAL=$?
1206    if test "x$RETVAL" != x0 ; then
1207        cat <<EOF 1>&2
1208    
1209    Error: The command "ln -s" failed -- please specify a working soft-link
1210      command in the optfile.
1211    
1212    EOF
1213        exit 1
1214    fi
1215    rm -f genmake_test_ln genmake_tlink
1216    
1217    #  Check for broken *.F/*.f handling and fix if possible
1218    check_for_broken_Ff
1219    
1220    if test ! "x$MPI" = x ; then
1221          echo "  Turning on MPI cpp macros"
1222          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1223    fi
1224    
1225    printf "\n===  Checking system libraries  ===\n"
1226    printf "  Do we have the system() command using $FC...  "
1227    cat > genmake_tcomp.f <<EOF
1228          program hello
1229          call system('echo hi')
1230          end
1231    EOF
1232    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1233    RETVAL=$?
1234    if test "x$RETVAL" = x0 ; then
1235        HAVE_SYSTEM=t
1236        DEFINES="$DEFINES -DHAVE_SYSTEM"
1237        echo "yes"
1238    else
1239        HAVE_SYSTEM=
1240        echo "no"
1241    fi
1242    rm -f genmake_tcomp*
1243    
1244    printf "  Do we have the fdate() command using $FC...  "
1245    cat > genmake_tcomp.f <<EOF
1246          program hello
1247          CHARACTER(128) string
1248          string = ' '
1249          call fdate( string )
1250          print *, string
1251          end
1252    EOF
1253    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1254    RETVAL=$?
1255    if test "x$RETVAL" = x0 ; then
1256        HAVE_FDATE=t
1257        DEFINES="$DEFINES -DHAVE_FDATE"
1258        echo "yes"
1259    else
1260        HAVE_FDATE=
1261        echo "no"
1262    fi
1263    rm -f genmake_tcomp*
1264    
1265    printf "  Do we have the etime() command using $FC...  "
1266    cat > genmake_tcomp.f <<EOF
1267          program hello
1268          REAL*4 ACTUAL, TARRAY(2)
1269          EXTERNAL ETIME
1270          REAL*4 ETIME
1271          actual = etime( tarray )
1272          print *, tarray
1273          end
1274    EOF
1275    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1276    RETVAL=$?
1277    if test "x$RETVAL" = x0 ; then
1278        HAVE_ETIME=t
1279        DEFINES="$DEFINES -DHAVE_ETIME"
1280        echo "yes"
1281    else
1282        HAVE_ETIME=
1283        echo "no"
1284    fi
1285    rm -f genmake_tcomp*
1286    
1287    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1288    check_HAVE_CLOC
1289    if test "x$HAVE_CLOC" != x ; then
1290        echo "yes"
1291    else
1292        echo "no"
1293    fi
1294    rm -f genmake_t*
1295    
1296    printf "  Can we create NetCDF-enabled binaries...  "
1297    check_netcdf_libs
1298    if test "x$HAVE_NETCDF" != x ; then
1299        echo "yes"
1300    else
1301        echo "no"
1302  fi  fi
1303    
1304    
1305  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1306  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1307  for d in $MODS ; do  for d in $MODS ; do
1308      if test ! -d $d ; then      if test ! -d $d ; then
1309          echo          echo
1310          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1311          exit 1          exit 1
1312      else      else
1313          echo -n " $d"          printf " $d"
1314          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1315          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1316      fi      fi
# Line 534  if test "x${PLATFORM}" = x ; then Line 1325  if test "x${PLATFORM}" = x ; then
1325  fi  fi
1326    
1327  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1328      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1329        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1330          EXEDIR=../exe          EXEDIR=../exe
1331      else      else
1332          EXEDIR=.          EXEDIR=.
# Line 549  if test "x${TOOLSDIR}" = x ; then Line 1341  if test "x${TOOLSDIR}" = x ; then
1341      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1342  fi  fi
1343  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1344      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1345      exit 1      exit 1
1346  fi  fi
1347  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1348      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1349  fi  fi
1350    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1351    
1352  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1353    
# Line 563  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1356  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1356  #  they appear as regular source code  #  they appear as regular source code
1357  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1358      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1359      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1360      RETVAL=$?      RETVAL=$?
1361      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1362          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1363      else      else
1364          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1365          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1366          exit 1          exit 1
1367      fi      fi
1368  fi  fi
1369    
1370    #same for exch2
1371    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1372        echo "  Making source files in exch2 from  templates"
1373        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1374        RETVAL=$?
1375        if test "x${RETVAL}" = x0 ; then
1376            rm -f make_exch2.errors
1377        else
1378            echo "Error: problem encountered while building source files in exch2:"
1379            cat make_exch2.errors 1>&2
1380            exit 1
1381        fi
1382    fi
1383    
1384  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1385  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1386      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 593  echo "  getting package dependency info Line 1400  echo "  getting package dependency info
1400  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
1401  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
1402  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
1403      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1404      > ./.pd_tmp      > ./.pd_tmp
1405  RETVAL=$?  RETVAL=$?
1406  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
1407      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1408      exit 1      exit 1
1409  fi  fi
1410  source ./.pd_tmp  . ./.pd_tmp
1411  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1412    
1413  echo  -n "  checking default package list:  "  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1414    #  file should eventually be added so that, for convenience, one can
1415    #  specify groups of packages using names like "ocean" and "atmosphere".
1416    echo "  checking default package list:  "
1417    if test "x${PDEFAULT}" = x ; then
1418        for i in "." $MODS ; do
1419            if test -r $i"/packages.conf" ; then
1420                    PDEFAULT=$i"/packages.conf"
1421                    break
1422            fi
1423        done
1424    fi
1425  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1426      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1427  fi  fi
1428  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1429      echo "default packages file disabled"      echo "    default packages file disabled"
1430  else  else
1431      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1432          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1433      else      else
1434          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1435          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1436          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1437          RETVAL=$?          RETVAL=$?
1438          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1439              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1440              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1441              exit 1              exit 1
1442          fi          fi
1443          for i in $def ; do          for i in $def ; do
1444              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1445          done          done
1446          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1447            RET=1
1448            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1449            echo "    after group expansion packages are:  $PACKAGES"
1450      fi      fi
1451  fi  fi
1452    
1453  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1454    for i in $PACKAGES ; do
1455        echo $i >> ./.tmp_pack
1456    done
1457    for i in `grep  "-" ./.tmp_pack` ; do
1458        j=`echo $i | sed 's/[-]//'`
1459        DISABLE="$DISABLE $j"
1460    done
1461  pack=  pack=
1462  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1463      addit="t"      addit="t"
# Line 645  for p in $PACKAGES ; do Line 1472  for p in $PACKAGES ; do
1472  done  done
1473  PACKAGES="$pack"  PACKAGES="$pack"
1474  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1475  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
1476  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1477    # Test if each explicitly referenced package exists
1478  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1479      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1480        if test ! -d "$ROOTDIR/pkg/$j" ; then
1481          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1482          exit 1          exit 1
1483      fi      fi
1484      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1485  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1486  PACKAGES=  PACKAGES=
1487  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1488      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1489  done  done
1490    rm -f ./.tmp_pack
1491  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1492    
1493    #  Check availability of NetCDF and then either build the MNC template
1494    #  files or delete mnc from the list of available packages.
1495    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1496    RETVAL=$?
1497    if test "x$RETVAL" = x0 ; then
1498        if test "x$HAVE_NETCDF" != xt ; then
1499            cat <<EOF
1500    
1501    *********************************************************************
1502    WARNING: the "mnc" package was enabled but tests failed to compile
1503      NetCDF applications.  Please check that:
1504    
1505      1) NetCDF is correctly installed for this compiler and
1506      2) the LIBS variable (within the "optfile") specifies the correct
1507           NetCDF library to link against.
1508    
1509      Due to this failure, the "mnc" package is now DISABLED.
1510    *********************************************************************
1511    
1512    EOF
1513            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1514            DISABLE="$DISABLE mnc"
1515        else
1516            ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1517            RETVAL=$?
1518            if test "x${RETVAL}" = x0 ; then
1519                rm -f make_mnc.errors
1520            else
1521                echo "Error: problem encountered while building source files in pkg/mnc:"
1522                cat make_mnc.errors 1>&2
1523                exit 1
1524            fi
1525        fi
1526    fi
1527    
1528  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1529  ck=  ck=
1530  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 726  while test "x$ck" != xtt ; do Line 1589  while test "x$ck" != xtt ; do
1589              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1590              exit 1              exit 1
1591          fi          fi
1592          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1593            #i=$(( $i + 1 ))
1594      done      done
1595      ck=$ck"t"      ck=$ck"t"
1596  done  done
# Line 736  for i in $PACKAGES ; do Line 1600  for i in $PACKAGES ; do
1600      if test -d $adr ; then      if test -d $adr ; then
1601          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1602          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1603            if test "x$i" = xautodiff ; then
1604                AUTODIFF_PKG_USED=t
1605            fi
1606      else      else
1607          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1608          exit 1          exit 1
1609      fi      fi
1610  done  done
1611    
1612  #  This is compatible with the old genmake.  The "DISABLE_*" flags  # Create a list of #define and #undef to enable/disable packages
1613  #  need to be replaced by the "ALLOW_*" flags set below.  PACKAGES_DOT_H=PACKAGES_CONFIG.h
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 echo "  Searching for CPP_OPTIONS.h (macros and flags for configuring the model):"  
 CPP_OPTIONS=  
 spaths=". $SOURCEDIRS"  
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 C  Packages disabled by genmake:  
 EOF  
1614  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1615  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1616  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1617  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1618  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1619  all_pack=  all_pack=
1620    DISABLED_PACKAGES=
1621  for n in $names ; do  for n in $names ; do
1622      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1623          has_pack="f"          has_pack="f"
# Line 813  for n in $names ; do Line 1628  for n in $names ; do
1628              fi              fi
1629          done          done
1630          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1631              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1632              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1633          fi          fi
1634      fi      fi
1635  done  done
1636  cat <<EOF >>CPP_OPTIONS.h.tmp  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1637  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1638      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1639      echo "#define $def" >> CPP_OPTIONS.h.tmp      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1640    #eh3 DEFINES="$DEFINES -D$def"
1641    
1642  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1643      case $i in      case $i in
1644          aim_v23)          aim_v23)
1645              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1646                echo "Warning: ALLOW_AIM is set to enable aim_v23."
1647              ;;              ;;
1648      esac      esac
1649  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1650    
1651  done  done
 mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  
1652    
1653  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1654  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1655  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1656  for d in $STANDARDDIRS ; do      STANDARDDIRS="eesupp model"
1657      adr="$ROOTDIR/$d/src"  fi
1658      if test ! -d $adr ; then  if test "x$STANDARDDIRS" != x ; then
1659          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""      for d in $STANDARDDIRS ; do
1660          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/src"
1661          exit 1          if test ! -d $adr ; then
1662      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1663          SOURCEDIRS="$SOURCEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1664      fi              exit 1
1665      adr="$ROOTDIR/$d/inc"          else
1666      if test ! -d $adr ; then              SOURCEDIRS="$SOURCEDIRS $adr"
1667          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          fi
1668          echo "  is correct and that you correctly specified the STANDARDDIRS option"          adr="$ROOTDIR/$d/inc"
1669          exit 1          if test ! -d $adr ; then
1670      else              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1671          INCLUDEDIRS="$INCLUDEDIRS $adr"              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1672                exit 1
1673            else
1674                INCLUDEDIRS="$INCLUDEDIRS $adr"
1675            fi
1676        done
1677    fi
1678    
1679    echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1680    echo "    of \"#define \"-type statements that are no longer allowed:"
1681    CPP_OPTIONS=
1682    CPP_EEOPTIONS=
1683    spaths=". $INCLUDEDIRS"
1684    names=`ls -1 "$ROOTDIR/pkg"`
1685    for i in $spaths ; do
1686        try="$i/CPP_OPTIONS.h"
1687        if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
1688            echo "    found CPP_OPTIONS=\"$try\""
1689            CPP_OPTIONS="$try"
1690            # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1691            for n in $names ; do
1692                test_for_package_in_cpp_options $CPP_OPTIONS $n
1693            done
1694        fi
1695        try="$i/CPP_EEOPTIONS.h"
1696        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1697            echo "    found CPP_EEOPTIONS=\"$try\""
1698            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1699    #**** not yet enabled ****
1700    #        test_for_mpi_in_cpp_eeoptions $try
1701    #**** not yet enabled ****
1702            CPP_EEOPTIONS="$try"
1703      fi      fi
1704  done  done
1705    if test "x$CPP_OPTIONS" = x ; then
1706        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1707        exit 1
1708    fi
1709    
1710    #  Here, we build the list of files to be "run through" the adjoint
1711    #  compiler.
1712    if test -f ./ad_files ; then
1713        rm -f ./ad_files
1714    fi
1715    echo "  Creating the list of files for the adjoint compiler."
1716    for i in $SOURCEDIRS ; do
1717        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1718        for j in $list_files ; do
1719            cat $i/$j >> ad_files
1720        done
1721    done
1722    
1723    
1724  echo  echo
1725  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1726  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1727  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1728      if test -d $i ; then      if test ! -d $i ; then
         INCLUDES="$INCLUDES -I$i"  
     else  
1729          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1730      fi      fi
1731  done  done
# Line 894  rm -rf .links.tmp Line 1735  rm -rf .links.tmp
1735  mkdir .links.tmp  mkdir .links.tmp
1736  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1737  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1738  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1739  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1740  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1741  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1742    printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1743  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1744  for d in $alldirs ; do  for d in $alldirs ; do
1745      deplist=      deplist=
1746      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1747      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1748      for sf in $sfiles ; do      for sf in $sfiles ; do
1749          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1750              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1751                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  case $d/$sf in
1752                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1753                  deplist="$deplist $sf"                          ;;
1754                      ./AD_CONFIG.h)
1755                            ;;
1756                      ./FC_NAMEMANGLE.h)
1757                            ;;
1758                      ./BUILD_INFO.h)
1759                            ;;
1760                      *)
1761                            touch .links.tmp/$sf
1762                            deplist="$deplist $sf"
1763                            ;;
1764                    esac
1765                    extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1766                  case $extn in                  case $extn in
1767                      F)                      F)
1768                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1769                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1770                          ;;                          ;;
1771                      F90)                      F90)
1772                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1773                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1774                          ;;                          ;;
1775                      c)                      c)
1776                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1777                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1778                          ;;                          ;;
1779                      h)                      h)
1780                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1781                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1782                            ;;
1783                        flow)
1784                            echo    " \\"  >> ad_flow_files.inc
1785                            printf " $sf" >> ad_flow_files.inc
1786                          ;;                          ;;
1787                  esac                  esac
1788              fi              fi
# Line 942  echo "" >> srclist.inc Line 1800  echo "" >> srclist.inc
1800  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1801  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1802  echo "" >> hlist.inc  echo "" >> hlist.inc
1803    echo "" >> ad_flow_files.inc
1804    
1805  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1806      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1807  fi  fi
1808  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 952  echo "#    $MACHINE" >> $MAKEFILE Line 1811  echo "#    $MACHINE" >> $MAKEFILE
1811  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1812  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1813  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1814  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1815  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1816  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1817    
1818    EXE_AD=$EXECUTABLE"_ad"
1819    EXE_FTL=$EXECUTABLE"_ftl"
1820    EXE_SVD=$EXECUTABLE"_svd"
1821    
1822  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1823    #
1824    # OPTFILE="$OPTFILE"
1825  #  #
1826  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1827  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 983  EXEDIR      = ${EXEDIR} Line 1849  EXEDIR      = ${EXEDIR}
1849  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1850  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1851    
1852    #eh3  new defines for the adjoint work
1853    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1854    EXE_AD      = ${EXE_AD}
1855    EXE_FTL     = ${EXE_FTL}
1856    EXE_SVD     = ${EXE_SVD}
1857    
1858    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1859    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1860    
1861    # These files are created by Makefile
1862    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1863    
1864  EOF  EOF
1865    
1866  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1000  KPP = ${KPP} Line 1878  KPP = ${KPP}
1878  FC = ${FC}  FC = ${FC}
1879  # Fortran compiler  # Fortran compiler
1880  F90C = ${F90C}  F90C = ${F90C}
1881    # C compiler
1882    CC = ${CC}
1883  # Link editor  # Link editor
1884  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1885    
1886  # Defines for CPP  # Defines for CPP
1887  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1028  MAKEFILE=${MAKEFILE} Line 1908  MAKEFILE=${MAKEFILE}
1908    
1909  EOF  EOF
1910    
1911  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1912  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1913  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1914  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1915  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1916  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo >> $MAKEFILE
1917    echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1918    echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1919  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1920    echo >> $MAKEFILE
1921    echo '.SUFFIXES:' >> $MAKEFILE
1922    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1923  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1924    rm -f ad_flow_files.inc
1925    
1926  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1927    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1928  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1929  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1930            @echo Creating \$@ ...
1931          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1932  depend:  depend:
1933          @make links          @make links
1934          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1935          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1936            -rm -f makedepend.out
1937    
1938  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1939    
1940  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1941    
# Line 1060  output.txt: \$(EXECUTABLE) Line 1944  output.txt: \$(EXECUTABLE)
1944          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1945    
1946  clean:  clean:
1947          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1948  Clean:  Clean:
1949          @make clean          @make clean
1950          @make cleanlinks          @make cleanlinks
1951          -rm -f Makefile.bak          -rm -f \$(SPECIAL_FILES)
1952            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1953  CLEAN:  CLEAN:
1954          @make Clean          @make Clean
1955          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1956          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1957          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1958          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt STD*
1959    
1960    #eh3 Makefile: makefile
1961  makefile:  makefile:
1962          ${0} $@          $THIS_SCRIPT $G2ARGS
1963  cleanlinks:  cleanlinks:
1964          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1965    
1966  # The normal chain of rules is (  .F - .f - .o  )  # Special targets (SPECIAL_FILES) which are create by make
1967  .F.f:  ${PACKAGES_DOT_H}:
1968            @echo Creating \$@ ...
1969            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1970    AD_CONFIG.h:
1971            @echo Creating \$@ ...
1972            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1973    FC_NAMEMANGLE.h:
1974            @echo Creating \$@ ...
1975            echo "$FC_NAMEMANGLE" > \$@
1976    
1977    BUILD_INFO.h:
1978            @echo Creating \$@ ...
1979    EOF
1980    
1981    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
1982    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
1983    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
1984    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
1985    
1986    cat >>$MAKEFILE <<EOF
1987    
1988    # The normal chain of rules is (  .F - .$FS - .o  )
1989    
1990    ## This nullifies any default implicit rules concerning these two file types:
1991    ## %.o : %.F
1992    
1993    .F.$FS:
1994          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1995  .f.o:  .$FS.o:
1996          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1997  .F90.f90:  .F90.$FS90:
1998          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1999  .f90.o:  .$FS90.o:
2000          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2001  .c.o:  .c.o:
2002          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2003    
2004  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2005  .F.p:  .F.p:
2006          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2007  .p.f:  .p.$FS:
2008          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2009    
2010    #=========================================
2011    #===  Automatic Differentiation Rules  ===
2012    
2013    TAMC           = ${TAMC}
2014    TAF            = ${TAF}
2015    
2016    TAF_EXTRA      = ${TAF_EXTRA}
2017    TAMC_EXTRA     = ${TAMC_EXTRA}
2018    
2019    EOF
2020    
2021    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2022    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2023    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2024    for i in $ad_vars ; do
2025        name=$i
2026        t1="t2=\$"`echo $i`
2027        eval $t1
2028        printf "%-20s = " $name >> $MAKEFILE
2029        echo $t2 >> $MAKEFILE
2030    done
2031    
2032    echo "  Add the source list for AD code generation"
2033    echo >> $MAKEFILE
2034    printf "AD_FILES = " >> $MAKEFILE
2035    AD_FILES=`cat ad_files`
2036    for i in $AD_FILES ; do
2037        echo    " \\" >> $MAKEFILE
2038        printf " $i" >> $MAKEFILE
2039    done
2040    echo >> $MAKEFILE
2041    rm -f ad_files
2042    
2043    cat >>$MAKEFILE <<EOF
2044    
2045    # ... AD ...
2046    adall: ad_taf
2047    adtaf: ad_taf_output.f
2048    adtamc: ad_tamc_output.f
2049    
2050    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2051            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2052            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2053            -rm -f ad_config.template
2054            @make \$(F77FILES)
2055            @make \$(AD_FLOW_FILES)
2056            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
2057    
2058    ad_taf_output.f: ad_input_code.f
2059            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2060            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2061    
2062    adtafonly:
2063            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2064            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2065    
2066    ad_taf: ad_taf_output.o \$(OBJFILES)
2067            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2068    
2069    ad_tamc_output.f: ad_input_code.f
2070            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
2071            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
2072    
2073    ad_tamc: ad_tamc_output.o \$(OBJFILES)
2074            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2075    
2076    
2077    # ... FTL ...
2078    ftlall: ftl_taf
2079    ftltaf: ftl_taf_output.f
2080    ftltamc: ftl_tamc_output.f
2081    
2082    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2083            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2084            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2085            -rm -f ftl_config.template
2086            @make \$(F77FILES)
2087            @make \$(AD_FLOW_FILES)
2088            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
2089    
2090    ftl_taf_output.f: ftl_input_code.f
2091            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2092            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2093    
2094    ftltafonly:
2095            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2096            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2097    
2098    ftl_taf: ftl_taf_output.o \$(OBJFILES)
2099            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2100    
2101    ftl_tamc_output.f: ftl_input_code.f
2102            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
2103            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
2104    
2105    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2106            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2107    
2108    
2109    # ... SVD ...
2110    svdtaf: ad_taf_output.f ftl_taf_output.f
2111    svdall: svd_taf
2112    
2113    svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
2114            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2115    
2116    
2117    #=========================================
2118    
2119  EOF  EOF
2120    
2121  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1108  for i in $KPPFILES ; do Line 2129  for i in $KPPFILES ; do
2129      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2130          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2131      fi      fi
2132      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2133  done  done
2134    
2135  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1118  for i in $NOOPTFILES ; do Line 2139  for i in $NOOPTFILES ; do
2139      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2140          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2141      fi      fi
2142      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2143      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2144  done  done
2145    
# Line 1131  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2152  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2152    
2153  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2154    
2155    # Create special header files
2156    $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2157    if test ! -f $PACKAGES_DOT_H ; then
2158        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2159    else
2160        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2161        RETVAL=$?
2162        if test "x$RETVAL" = x0 ; then
2163            rm -f $PACKAGES_DOT_H".tmp"
2164        else
2165            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2166            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2167        fi
2168    fi
2169    if test ! -f AD_CONFIG.h ; then
2170        $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2171    fi
2172    
2173    
2174  #  Write the "state" for future records  #  Write the "state" for future records
2175  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2176      echo -n "" > gm_state      printf "" > genmake_state
2177      for i in $gm_state ; do      for i in $gm_state ; do
2178          t1="t2=\$$i"          t1="t2=\$$i"
2179          eval $t1          eval $t1
2180          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
2181      done      done
2182  fi  fi

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.102

  ViewVC Help
Powered by ViewVC 1.1.22